{% extends "elections2021/base.html" %}
{% load wagtailcore_tags wagtailimages_tags elections2021_extras %}

{% block content %}
<div class="container container-default pt-4 pb-20">
  <div class="w-full lg:w-4/6 relative container-collapsible">

    <div class="floating-nav-wrapper hidden xl:block" id="floatingNavBarWrapper">
      <div class="floating-nav-panel " id="floatingNavBar">
        <div class="opener py-6 pb-16 px-11 bg-acidgreen text-white font-alt">
          RYCHLÁ NAVIGACE
        </div>
        <div class="inner float-panel-inner elevation-2">
          <ul>
            <li><a href="#takhle-to-dal-nejde">Takhle to dál nejde</a></li>
            <li><a href="#v-cem-je-problem">V čem je problém</a></li>
            <li><a href="#nase-vize">Naše vize</a></li>
            <li><a href="#jak-to-chceme-udelat" class="active">Jak to chceme udělat?</a></li>
            <li><a href="#kolik-na-to-chceme-casu">Kolik na to chceme času?</a></li>
            {% if page.benefits_main or page.benefits %}
              <li><a href="#pro-koho-to-chceme-hlavne">Pro koho to chceme hlavně</a></li>
            {% endif %}
            <li><a href="#co-pro-to-uz-delame">Co pro to už děláme</a></li>
            <li><a href="#na-co-se-nas-casto-ptate">Na co se nás často ptáte</a></li>
            {% if page.related_points %}
              <li><a href="#souvisejici-body">Související body</a></li>
            {% endif %}
            <li><a href="#zdroje">Klidně si to ověřte</a></li>
          </ul>
        </div>
      </div>
    </div>

    <script>
      window.addEventListener("load", onLoadFunction);
      var anchorsArray = [];

      function placeUponId(id, space) {
        return document.getElementById(id).getBoundingClientRect().top + window.scrollY - space;
      }

      function onLoadFunction(e) {
        var anchorElemsArray;
        onResizeFunction();
        for (const entry of anchorsArray) {
          entry.menuitem.addEventListener("click", clickHandler);
        }

        function clickHandler(e) {
          e.preventDefault();
          var id = this.getAttribute("href").replace("#", "");
          console.log(placeUponId(id, 20));
          scroll({
            top: placeUponId(id, 20),
            behavior: "smooth"
          });
        }


        window.addEventListener("resize", onResizeFunction);
      }

      function onResizeFunction(e) {
        var itemsProcessed = 0;
        var anchorElemsArray = document.getElementsByClassName("float-panel-inner")[0].querySelectorAll("li a");
        anchorsArray = [];
        anchorElemsArray.forEach(function(entry) {
          var id = entry.getAttribute("href").replace("#", "");
          anchorsArray.push({
            id: id,
            top: placeUponId(id, 200),
            menuitem: entry
          });
          itemsProcessed++;
          if (itemsProcessed === anchorElemsArray.length) {
            anchorsArray.reverse();
          }
        });
        console.log(anchorsArray);
      }
      window.onscroll = function() {
        var top = window.pageYOffset || document.documentElement.scrollTop;
        var activereached = false;
        anchorsArray.forEach(function(entry) {
          entry.menuitem.classList.remove("active");
          entry.menuitem.classList.remove("passed");
          if (top >= placeUponId(entry.id, 200)) {
            if (activereached) entry.menuitem.classList.add("passed");
            else entry.menuitem.classList.add("active");
            activereached = true;
          }
        });
      };
    </script>

    <header class="w-full md:w-5/6">
      <div class="mt-10 md:mt-12">
        <h1 class="head-alt-md md:head-alt-lg head-alt-highlighted">{{ page.title }}</h1>
        <h2 class="head-alt-sm md:head-alt-md mb-20 mt-9">
          <div class="leading-tight">{{ page.annotation|richtext|format_sources }}</div>
        </h2>
      </div>
    </header>

    <div class="problem-pack">
      <section id="takhle-to-dal-nejde" class="program-detail-problem-solution mb-20">

        <div class="problem-cross"><i class="ico--thincross text-xs sm:text-xl text-white"></i></div>
        <div class="problem-inner content-block">

          <h2 class="head-alt-sm md:head-alt-md mb-9">Takhle to dál nejde</h2>
          <p class="text-base mb-8 para">
            {{ page.problem|richtext|format_sources }}
          </p>

          <div id="v-cem-je-problem">
            <div class="accordeon-row accordeon-row--fadeout h-full">
              <div class="accordeon-row-head" v-on:click="toggleElement" onclick="if(this.parentElement.classList.contains('accordeon-row--open')) this.parentElement.classList.remove('accordeon-row--open'); else this.parentElement.classList.add('accordeon-row--open');">
                <h3 class="accordeon-row-heading head-alt-xs mb-0">V čem je problém</h3>
                <i class="ico--chevron-down"></i>
              </div>
              <div class="accordeon-row-body accordeon-row-body--fadeout" style="height: 220px; max-height: 560px;">
                <div>
                  {{ page.context|richtext|format_sources }}
                </div>
              </div>
              <button class="btn btn--icon absolute bottom-8 left-8" onclick="this.parentElement.classList.add('accordeon-row--open');">
                <div class="btn__body-wrap">
                  <div class="btn__body bg-acidgreen -bottom-20 text-black py-4">Zobrazit více</div>
                  <div class="btn__icon bg-black">
                    <i class="ico--chevron-right"></i>
                  </div>
                </div>
              </button>
            </div>
          </div>
        </div>

        <div id="nase-vize" class="ideal-check"><i class="ico--check text-xs sm:text-xl text-black"></i></div>
        <div class="ideal-inner bg-lemon content-block">
          <h2 class="head-alt-sm md:head-alt-md mb-9">Naše vize</h2>
          <p class="text-base">
            {{ page.ideal|richtext|format_sources }}
          </p>
        </div>

      </section>
    </div>

    <div id="jak-to-chceme-udelat" class="container-collapsible-content" style="height: 50vh;">

      <h3 class="head-alt-base mb-8">Jak to chceme udělat?</h3>
      <div class="content-block">
        {{ page.proposal|richtext|format_sources|style_h4 }}
      </div>

      <div id="kolik-na-to-chceme-casu" class="grid grid-cols-1 gap-8 my-20">
        {% if page.time_horizon_number %}
          <aside class="bg-grey-125 text-black px-4 py-10 lg:py-10 lg:px-10 countdown-small ">
            <div class="flex flex-col lg:flex-row items-center">
              <h1 class="head-alt-sm flex-grow text-center lg:text-left mb-8 lg:mb-0 mt-1">Kolik na to chceme času?</h1>
              <div class="__js-root ">
                <div class="flip-clock">
                  <span class="flip-clock__piece flip">
                    <span class="flip-clock__card flip-card">
                      <b class="flip-card__top">{{ page.time_horizon_number }}</b>
                      <b data-value="{{ page.time_horizon_number }}" class="flip-card__bottom"></b>
                      <b data-value="{{ page.time_horizon_number }}" class="flip-card__back"></b>
                      <b data-value="{{ page.time_horizon_number }}" class="flip-card__back-bottom"></b>
                    </span>
                    <span class="flip-clock__slot font-alt text-2xl">{{ page.time_horizon_unit }}</span>
                  </span>
                </div>
              </div>
            </div>
          </aside>
        {% endif %}
        {% if page.time_horizon_text %}
          <div class="card shadow-none bg-grey-125">
            <div class="card__body content-block">
              <h3 class="card-headline mb-8">Kolik na to chceme času?</h3>
              <p class="card-body-text para">{{ page.time_horizon_text|richtext|format_sources }}</p>
            </div>
          </div>
        {% endif %}
      </div>

      {% if page.benefits_main or page.benefits %}
        <h3 id="pro-koho-to-chceme-hlavne" class="head-alt-base mb-8 mt-20">Pro koho to chceme hlavně</h3>
      {% endif %}

      {% if page.benefits_main %}
        <div class="program-detail-benefity my-8 grid grid-cols-1 sm:grid-cols-2 gap-4 lg:gap-8">
          {% for block in page.benefits_main %}
            {% include_block block %}
          {% endfor %}
        </div>
      {% endif %}

      {% if page.benefits %}
        <div class="program-detail-benefity my-8 grid grid-cols-1 sm:grid-cols-2 gap-4 lg:gap-8">
          {% for block in page.benefits %}
            {% include_block block %}
          {% endfor %}
        </div>
      {% endif %}

      {% if page.benefit_for_all %}
        <h3 class="head-alt-lg mb-20 text-3xl md:text-5xl leading-tight mt-24">{{ page.benefit_for_all|richtext|format_sources }}</h3>
      {% endif %}

      <h3 id="co-pro-to-uz-delame" class="head-alt-base mt-20 mb-10">Co pro to už děláme</h3>
      <div class="content-block">
        {{ page.already_done|richtext|format_sources|style_h4 }}
      </div>

      <h3 id="na-co-se-nas-casto-ptate" class="head-alt-base mb-8 mt-20">Na co se nás často ptáte</h3>
      <div class="space-y-1">
        {% for block in page.faq %}
          {% include_block block %}
        {% endfor %}
      </div>

      {% if page.related_points %}
        <h3 id="souvisejici-body" class="head-alt-base mb-8 mt-20">Související body:</h3>

        <div class="carousel-card-list __js-root">
          <ui-app inline-template>
            <ui-carousel>
              <!--<carousel :perPage="4" :perPageCustom="[ [200, 1], [768, 3], [1024, 4]]" :navigationEnabled="true" :navigationNextLabel="nextlabel" :navigationPrevLabel="prevlabel" class="article-card-list pt-12 pb-8">-->
              <carousel :per-page=1 :navigation-enabled="true" class="article-card-list pb-8">

                <slide>
                  <div class="grid grid-cols-1 md:grid-cols-2 gap-2 md:gap-8">

                    {% for point in page.related_points %}
                      <div class="card shadow-none bg-grey-125 card--hoveractive">
                        <div class="card__body">
                          <h1 class="card-headline mb-8"><a href="{% pageurl point.value %}">{{ point.value.title }}</a></h1>
                          <div class="card-body-text"><a href="{% pageurl point.value %}">{{ point.value.annotation|richtext|strip_sup }}</a></div>
                        </div>
                      </div>
                      {% if forloop.counter|divisibleby:"4" and not forloop.last %}
                          </div>
                        </slide>
                        <slide>
                          <div class="grid grid-cols-1 md:grid-cols-2 gap-2 md:gap-8">
                      {% endif %}
                    {% endfor %}

                  </div>
                </slide>

              </carousel>
            </ui-carousel>
          </ui-app>
        </div>
      {% endif %}

      <h3 id="zdroje" class="head-alt-base mb-8 mt-20">Klidně si to ověřte</h3>
      <div class="content-block">
        {{ page.sources|richtext|format_sources_block }}
      </div>

    </div>

    <div class="container-collapsible-button-container w-full">
      <button class="container-collapsible-button btn btn--icon text-lg block mx-auto" onclick="this.parentElement.parentElement.classList.add('container-collapsible-open');">
        <div class="btn__body-wrap">
          <div class="btn__body py-8 leading-4">Zobrazit více</div>
          <div class="btn__icon px-8 bg-grey-800 border-grey-500">
            <i class="ico--chevron-right"></i>
          </div>
        </div>
      </button>
    </div>

  </div>
</div>

<script>
  /*should run once on any page accordeon rows with fadeouts are present*/
  document.addEventListener("DOMContentLoaded", setMaxHeightsFadeouts);
  window.addEventListener('resize', setMaxHeightsFadeouts);

  function setMaxHeightsFadeouts() {
    // set height for css transition
    var accordeonRowBodies = document.getElementsByClassName('accordeon-row-body--fadeout');

    if (accordeonRowBodies !== null) {
      for (var i = 0; i < accordeonRowBodies.length; i++) {
        accordeonRowBodies[i].style.maxHeight = (parseInt(accordeonRowBodies[i].scrollHeight) + 32) + "px";
      }; /*plus padding*/
    }
  }

  document.addEventListener("DOMContentLoaded", setMaxHeights);
  window.addEventListener('resize', setMaxHeights);

  function setMaxHeights() {
    // set height for css transition
    var accordeonRowBodies = document.getElementsByClassName('accordeon-row-body--classic');

    if (accordeonRowBodies !== null) {
      for (var i = 0; i < accordeonRowBodies.length; i++) {
        accordeonRowBodies[i].style.maxHeight = accordeonRowBodies[i].scrollHeight + "px";
      };
    }
  }
</script>

{% endblock %}
